% Change k every where
function L = Colorize(I1,I2,thresh)

if nargin == 2
	thresh = 0;
end		
k = 4;		% neighborhood
default = 0.5020;

% classification and image space voting

[glabel,best,Wt,conf,lab_I] = colorClassify(I1,I2);

%save('varfile.mat');
%load('varfile.mat');

dim1 = size(I1(:,:,1));			% reference image
dim2 = size(I2);			% target image

k1 = idivide(k,int32(2));
k2 = k*k;

% find x,y coordinate of best , 
% best has dimention equivalent to dim2 , values belongs to dim1 
X = @(m) (idivide(m,int32(dim1(2)))+1);		% not correct when m is perfect integer // will check in code	
Y = @(m) (m - (X(m)-1)*dim1(2)); 	

% find coordiante of best match from array best
temp = size(best);
new1 = zeros(temp);
new2 = zeros(temp);
d1 = size(I2);

lab_I2 = uint8(zeros(d1(1),d1(2),3));
lab_I2 = im2double(lab_I2);
%lab_I2(:,:,1) = I2;

U2 = zeros(d1);
V2 = zeros(d1);
tic
for i=1:temp(1)
	for j=1:temp(2)
		a = X(best(i,j));
		b = Y(best(i,j));
		if(b==0)
			b=temp(1);
			a = a-1;
		end
		new1(i,j) = a;			% coordinates of best match in reference image
		new2(i,j) = b;
	end
end
toc			
U1 = lab_I(:,:,2);
V1 = lab_I(:,:,3);
%save('varfile.mat');

U2 = zeros(d1);
V2 = zeros(d1);
U = 0.0;
V = 0.0;
tic
for i=1:dim2(1)
	
	x = min(dim2(1)-k+1,max(1,i-k1));

	for j=1:dim2(2)

		y = min(dim2(2)-k+1,max(1,j-k1));

		%tmp = glabel(x:x+k-1,y:y+k-1);		% k neighbours 
		%count = 0;
		if(conf(i,j)>=thresh)	
			for a=x:x+k-1						% a,b position of q,
				for b=y:y+k-1
				%	if(glabel(i,j)==glabel(a,b))
						x1 = new1(a,b);			% position  of Mq
						y1 = new2(a,b);

						dx = a-i;				% position of q relative to p
						dy = b-j;

						x2 = x1 + dx;			% position of Mq(p)
						y2 = y1 + dy;

						if(x2 > dim1(1))
							x2 = dim1(1);
						elseif x2<=0
							x2 = 1;
						end

						if y2>dim1(2)
							y2 = dim1(2);
						elseif y2<=0
							y2 = 1;
						end
	%					a
	%					b
	%					x2
	%					y2
						U2(i,j) = U2(i,j) + Wt(a,b)*U1(x2,y2);
						V2(i,j) = V2(i,j) + Wt(a,b)*V1(x2,y2);
					%	U2(i,j) = U2(i,j) + U1(x2,y2);
					%	V2(i,j) = V2(i,j) + V1(x2,y2);
					%	count = count + 1;
				%	end
				end
			end
		else
			U2(i,j) = 	default;
			V2(i,j) = 	default;
		end			
		%count			
		%lab_I2(i,j,2) = U2(i,j)/count;
		%lab_I2(i,j,3) = V2(i,j)/count;
		%U2(i,j)
		%V2(i,j)				
		
	end
end
toc

lab_I2(:,:,1) = I2;
lab_I2(:,:,2) = U2;
lab_I2(:,:,3) = V2;

% default = 0.5020
%cform = makecform('lab2srgb');
%L = applycform(lab_I2,cform);
L  = ycbcr2rgb(lab_I2);