function [A1,A2,A3,A4,A5] = colorClassify(I1,I2)

% I1 colored  image  and I2 is grayscale image 

segments = 5;
numSample = 30000;
n = 250; 	% from each dimention
knn = 5;
dim1 = size(I1);
dim2 = size(I2);
 
[lab_I,label] = imsegment(I1,segments);
ftr=myfeature(I1(:,:,1));								% feature space of dim 49 

T  = myTransformMatrix(ftr,label,segments);		% subspace of dim 10

grayftr = myfeature(I2);						% I2 must be a grayscale image
%load('varfile.mat');
[graylabel,sam] = Gclassify(grayftr,ftr,label,T,knn,n,dim2);	% sam is projected grayftr columns


%save('varfile.mat');
%load('varfile.mat');
lowftr = (T*ftr')';
tic
[conf,graylabel,Wt,best] = ImageSpaceVoting(sam,graylabel,lowftr,label,knn+2);
%best is linear coordinate of best match 
toc
A1 = graylabel;
A2 = best;
A3 = Wt;
A4 = conf;
A5 = lab_I;
;
function [L1,L2,Wt,best] = ImageSpaceVoting(fm,lb1,f,lbf,knn)
k = 4; 		% neighbourhood
dim = size(lb1);
dim1 = size(fm);	%fm and lb1 must hav same no. of rows
dimlf = size(lbf);
dimf = size(f);

[tmp1,tmp2] = knnsearch(f,fm,'K',knn);		% this is wrong .. nearest neighbour with SAME LABEL
%D = double(tmp2(:,2));
lb2 = reshape(lb1',dim(1)*dim(2),1);
lb3 = reshape(lbf',dimlf(1)*dimlf(2),1);

D = zeros(dim(1)*dim(2),1);
B = zeros(dim(1)*dim(2),1);;
dim2  = size(tmp1); 
for i=1:dim1(1)
	for j=1:dim2(2)
		if(lb2(i)==lb3(tmp1(i,j)))		% lb3 is in reference image , lb2 is in target image
			D(i) = tmp2(i,j);
			B(i) = tmp1(i,j);
			break;
		end
	end
end			
best = reshape(B,dim(2),dim(1))';
D = reshape(D,dim(2),dim(1))';
D = exp(-D);

			
%clearvars fm;
% weight calculation
k1 = idivide(k,int32(2));
k2 = k*k;


fun = @(x) sum(x(:));
%Wt = nlfilter(D,[k k],fun);
%Wt = Wt - D;
Wt = D;
Sk = nlfilter(D,[k k],fun);
Wt = Wt./(Sk);
% conf calcuation
%dim
%size(Wt)
%size(Sk)

%Wt2 = nlfilter(Wt,[k k],fun);
%Wt2 = Wt2 - Wt;
for i=1:dim(1)

	x = min(dim(1)-k+1,max(1,i-k1));

	for j=1:dim(2)
		
		y = min(dim(2)-k+1,max(1,j-k1));

		tmp = sum(Wt(x:x+k-1,y:y+k-1));
		tmp = sum(tmp(:));
		sm = 0;
		for t1=x:x+k-1
			for t2=y:y+k-1
				if(lb1(t1,t2)==lb1(i,j) && ~(t1==i && t2==j))
					sm = sm + Wt(t1,t2);
				end
			end
		end
		conf(i,j) = sm/tmp;			
		
	end
end
		
L1 = conf;
% replace label

for i=1:dim(1)

	x = min(dim(1)-k+1,max(1,i-k1));
	for j=1:dim(2)
		
		y = min(dim(2)-k+1,max(1,j-k1));
		%tmp = sum(D(x:x+k-1,y:y+k-1));
		mm=0;
		for t1=x:x+k-1
			for t2=y:y+k-1
				if(conf(t1,t2)>mm)
					ll = lb1(t1,t2);
					mm = conf(t1,t2);
				end
			end
		end
		L2(i,j)=ll;
	end
end

return;


;	
function [L,K] = Gclassify(f1,f2,lbl,T,knn,n,dd)
dim1 = size(f1);	%gray feature
dim2 = size(lbl);	% labels of reference image
dim3 = size(f2);
total = 10;
m=1;

%for i=1:dd(1)
%	for j=1:dd(2)
%		v=f1(dd(2)*(i-1)+j,:);
%		sample(m,:)=T*v';
%		m = m+1;
%	end
%end
sample = (T*f1')';

rx  = randsample(dim2(1),n);
ry  = randsample(dim2(2),n);
m=1;
for i=1:n
	for j=1:n
		v=f2(dim2(2)*(rx(i)-1)+ry(j),:);
		training(m,:)=T*v';
		label(m) = lbl(rx(i),ry(j));
		m = m+1;
	end
end
%points = randsample(dim3(1),n*n);
%raining = (T*f2(points,:)')';
%lbl1 = reshape(lbl,dim2(1)*dim2(2),1);
%label = lbl1(points);

T1 = knnclassify(sample,training,label,knn);
m=1;

for i=1:dd(1)
	for j=1:dd(2)
		L(i,j) = T1(m);
		m = m+1;
	end
end

K = sample;
return;
;


function T =myTransformMatrix(F,L,seg)
dim = size(L);

pcadata = 1000;
s = struct('x',0,'y',0,'label',0);
data1 = repmat(s,dim(1)*dim(2),1);		% struct preallocation
k=1;
tic
for i=1:dim(1)
	for j=1:dim(2)
		data1(k).x = i;
		data1(k).y = j;
		data1(k).label = L(i,j);
		k = k+1;
	end
end
toc
k = length(data1);

% get inter-difference vectors
p1 = randsample(k,pcadata);
inter_v = zeros(pcadata,length(F(1,:)));
tic
for i=1:pcadata
	t1=1;
	t2=data1(p1(i)).label;
	tmp = zeros(k,1);
	for j=1:k
		if(data1(j).label ~= t2)
			tmp(t1)=j;
			t1 = t1+1;
		end
	end	
	t1 = t1-1;		% length of tmp
	vec = randsample(tmp(1:t1),1);
	v1 = F(dim(2)*(data1(p1(i)).x -1) + data1(p1(i)).y,:);
	v2 = F(dim(2)*(data1(vec).x -1) + data1(vec).y,:);
	%v1 = v1(:);
	%v2 = v2(:);
	inter_v(i,:) = (v1-v2);
end
toc
p1 = randsample(k,pcadata);
intra_v = zeros(pcadata,length(F(1,:)));
tic
for i=1:pcadata
	t1=1;
	t2=data1(p1(i)).label;
	tmp = zeros(k,1);
	for j=1:k
		if(data1(j).label == t2)
			tmp(t1)=j;
			t1 = t1+1;
		end
	end	
	t1 = t1-1;
	vec = randsample(tmp(1:t1),1);
	v1 = F(dim(2)*(data1(p1(i)).x -1) + data1(p1(i)).y,:);
	v2 = F(dim(2)*(data1(vec).x -1) + data1(vec).y,:);
	%v1 = v1(:);
	%v2 = v2(:);
	intra_v(i,:) = (v1-v2);
end
toc
clearvars data1;
tic
W1 = pca(inter_v,'Centered', false);
W2 = pca(intra_v,'Centered', false);
toc
% taking 10 dimesional sub space 
total = 10;
first = 6;
last = total-first;
T = zeros(total,length(W1(:,1)));
for i=1:first
	T(i,:) = W1(:,i)';
end
k=first+1;
for i=length(W2)-last+1:length(W2)
	T(k,:) = W2(:,i)';
	k = k+1;
end		

;
